include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "div_mod.ma".
include "logic.ma".
include "nat.ma".
include "relations.ma".
axiom divides : nat -> nat -> Prop.
axiom quotient : \forall (n:nat). \forall (m:nat). \forall (q:nat). ((eq) (nat) m ((times)  n q)) -> (divides)  n m.
definition reflexive_divides : (reflexive) (nat) (divides)  := \lambda x : nat. ((((quotient) (x)) (x)) ((S)  (O) )) (((((((rewrite_r) (nat)) ((times)  x ((S)  (O) ))) (\lambda j__ : nat. (eq) (nat) j__ ((times)  x ((S)  (O) )))) (((refl) (nat)) ((times)  x ((S)  (O) )))) (x)) ((times_n_1) (x))).
definition mod_O_to_divides : \forall (n:nat). \forall (m:nat). ((lt)  (O)  n) -> ((eq) (nat) ((mod)  m n) (O) ) -> (divides)  n m := \lambda n : nat. \lambda m : nat. \lambda auto : (lt)  (O)  n. (\lambda auto' : (eq) (nat) ((mod)  m n) (O) . (((((quotient) (n)) (m)) ((div)  m n)) (((((((rewrite_l) (nat)) ((times)  n ((div)  m n))) (\lambda j__ : nat. (eq) (nat) j__ ((times)  n ((div)  m n)))) (((refl) (nat)) ((times)  n ((div)  m n)))) (m)) (((((((rewrite_r) (nat)) ((minus)  m (O) )) (\lambda j__ : nat. (eq) (nat) ((times)  n ((div)  m n)) j__)) (((((((rewrite_l) (nat)) ((mod)  m n)) (\lambda j__ : nat. (eq) (nat) ((times)  n ((div)  m n)) ((minus)  m j__))) (((((((rewrite_l) (nat)) ((times)  ((div)  m n) n)) (\lambda j__ : nat. (eq) (nat) j__ ((minus)  m ((mod)  m n)))) (((eq_times_div_minus_mod) (m)) (n))) ((times)  n ((div)  m n))) (((commutative_times) ((div)  m n)) (n)))) ((O) )) (auto'))) (m)) ((minus_n_O) (m)))))).
definition divides_n_n : \forall (n:nat). (divides)  n n := \lambda n : nat. (reflexive_divides) (n).
definition dividesb : nat -> nat -> bool := \lambda n : nat. \lambda m : nat. (eqb)  ((mod)  m n) (O) .
definition dividesb_true_to_divides : \forall (n:nat). \forall (m:nat). ((eq) (bool) ((dividesb)  n m) (true) ) -> (divides)  n m := \lambda n : nat. \lambda m : nat. ((((((match_Or_prop) ((lt)  (O)  n)) ((eq) (nat) (O)  n)) (((eq) (bool) ((dividesb)  n m) (true) ) -> (divides)  n m)) (\lambda posn : (lt)  (O)  n. (\lambda divbnm : (eq) (bool) ((dividesb)  n m) (true) . (((((mod_O_to_divides) (n)) (m)) (posn)) ((((eqb_true_to_eq) ((mod)  m n)) ((O) )) (divbnm)))))) (\lambda eqnO : (eq) (nat) (O)  n. (((((((eq_ind) (nat)) ((O) )) (\lambda x_1 : nat. ((eq) (bool) ((dividesb)  x_1 m) (true) ) -> (divides)  x_1 m)) ((((((sym_eq_match_nat_type_O) (nat)) (m)) (\lambda p : nat. (mod_aux)  m m p)) (\lambda y : nat. ((eq) (bool) ((eqb)  y (O) ) (true) ) -> (divides)  (O)  m)) (\lambda eqbmO : (eq) (bool) ((eqb)  m (O) ) (true) . (((((((eq_ind_r) (nat)) ((O) )) (\lambda x : nat. (divides)  (O)  x)) ((divides_n_n) ((O) ))) (m)) ((((eqb_true_to_eq) (m)) ((O) )) (eqbmO)))))) (n)) (eqnO)))) ((((le_to_or_lt_eq) ((O) )) (n)) ((le_O_n) (n))).
